CharAge = {}
local CharAge = CharAge

CharAge.name = "CharacterAge"
CharAge.version = "1.0.3"

local formatString = {
    en = "Your character <<1>> exists since <<3>> <<i:2>> <<4>>, based on your first achievement: <<5>>",
    de = "Euer Charakter <<1>> existiert seit dem <<2>>. <<3>> <<4>>, basierend auf Eurer ersten Errungenschaft: <<5>>",
    fr = "Votre personnage <<1>> existe depuis le <<i:2>> <<3>> <<4>>, basé sur votre accomplissement: <<5>>",
}

function GetFirstAchievement()
    local oldestTimestamp = GetTimeStamp()
    local oldestAchievment
    
    for i = 1, 3000 do
        local _, _, _, _, completed, date, time = GetAchievementInfo(i)
        if completed then
			local timestamp = tonumber(Id64ToString(GetAchievementTimestamp(i)))
            if timestamp < oldestTimestamp then
                oldestTimestamp = timestamp
                oldestAchievment = i
            end
        end
    end
    
    return oldestAchievment, oldestTimestamp
end

local function OnAddonLoaded(event, addonName)
    if addonName ~= CharAge.name then return end
    EVENT_MANAGER:UnregisterForEvent(CharAge.name, EVENT_ADD_ON_LOADED) 
    
    SLASH_COMMANDS["/age"] = function()
        local id, ts = GetFirstAchievement()
        CHAT_ROUTER:AddSystemMessage(zo_strformat(formatString[GetCVar("language.2")] or formatString["en"], GetUnitName("player"), os.date("%d", ts), os.date("%B", ts), os.date("%Y", ts), ZO_LinkHandler_CreateChatLink(GetAchievementLink, id)))
    end
end
EVENT_MANAGER:RegisterForEvent(CharAge.name, EVENT_ADD_ON_LOADED, OnAddonLoaded)